// Copyright (c) 2006-2009 Nokia Corporation and/or its subsidiary(-ies).
// All rights reserved.
// This component and the accompanying materials are made available
// under the terms of "Eclipse Public License v1.0"
// which accompanies this distribution, and is available
// at the URL "http://www.eclipse.org/legal/epl-v10.html".
//
// Initial Contributors:
// Nokia Corporation - initial contribution.
//
// Contributors:
//
// Description:
//

#ifndef CARDGAMERECV_H
#define CARDGAMERECV_H

#include <e32base.h>
#include <in_sock.h>

class CCardGameBase;

/**
 * CCardGameRecv is an active object that has a reference to the RSocket of the network.
 * It calls RecvFrom on the socket and then calls back to the CCardGameBase object when 
 * the recv has completed
 */
class CCardGameRecv : public CActive
	{
public:
	static CCardGameRecv* NewL(CCardGameBase& aParent, RSocket& aSocket);
	~CCardGameRecv();
	void DoCancel();
	void RunL();
	void RecvFrom(TDes8& aDes);
	
private:
	CCardGameRecv(CCardGameBase& aParent, RSocket& aSocket);

private:
	CCardGameBase& iParent;
	RSocket& iSocket;
	TInetAddr iRecvAddr;
	
	};
	
#endif // CARDGAMERECV_H
