// Copyright (c) 1999-2009 Nokia Corporation and/or its subsidiary(-ies).
// All rights reserved.
// This component and the accompanying materials are made available
// under the terms of "Eclipse Public License v1.0"
// which accompanies this distribution, and is available
// at the URL "http://www.eclipse.org/legal/epl-v10.html".
//
// Initial Contributors:
// Nokia Corporation - initial contribution.
//
// Contributors:
//
// Description:
//


#ifndef __TXTMBOX_H__
#define __TXTMBOX_H__

#include <e32base.h>
#include <f32file.h>
#include <msvstd.h>
#include <msventry.h>
#include <e32def.h>
#include "TXUT.H"

//
//	CTxtRefreshMBox: refresher class to synchronize real folder and service
//

class CTxtRefreshMBox : public CBase
	{
	public:
		static CTxtRefreshMBox* NewL(RFs& aFs, TFileName& aRelativePath, 
			TMsvId aCurrentRootEntryId, CMsvServerEntry *aEntry, TMsvId aServiceEntryId,
			const TMTMTxtSettings& aTxtSettings);
		~CTxtRefreshMBox();
		TBool DoStepL(); // Returns ETrue if finished.
	private: // Construction
		CTxtRefreshMBox(RFs& aFs,TFileName& aRelativePath, TMsvId aCurrentRootEntryId, 
			CMsvServerEntry *aEntry, TMsvId aServiceEntryId, const TMTMTxtSettings& aTxtSettings) 
			: iFs(aFs) , iRelativePath(aRelativePath), iCurrentRootEntryId(aCurrentRootEntryId), 
			iEntry(aEntry), iTxtSettings(aTxtSettings), iServiceEntryId(aServiceEntryId)
			{};
		void ConstructL();
	private: // Tools
		TInt CreateChild(const TDesC& aDescription, const TDesC& aDetails, 
			TUid aMessageType, const TTime& aDate, const TInt aSize);
		void DeleteEntryL();
		TMsvId InsertFileL();
	private:
		RFs&  iFs;
		TFileName& iRelativePath;
		TMsvId	iCurrentRootEntryId;
		CDir* iFilelist;
		CMsvServerEntry* iEntry;
		CMsvEntrySelection* iExistingEntries;
		
		TInt iCurrentFile;	// index for file list
		TInt iCurrentEntry;	// index for entry list
		const TMTMTxtSettings& iTxtSettings;
		TMsvId iServiceEntryId;
	};
#endif
