// Copyright (c) 2007-2009 Nokia Corporation and/or its subsidiary(-ies).
// All rights reserved.
// This component and the accompanying materials are made available
// under the terms of "Eclipse Public License v1.0"
// which accompanies this distribution, and is available
// at the URL "http://www.eclipse.org/legal/epl-v10.html".
//
// Initial Contributors:
// Nokia Corporation - initial contribution.
//
// Contributors:
//
// Description:
// This gets the application specific UID and the document object.
//



/**
 @file
*/

#include "CameraExample.h"

const TUid KUidCamera = { 0xE80000B4 };

/** 
Called by the UI framework to get the application's UID
@return const TUid
@leave KErrNotFound
*/ 
TUid CCameraApplication::AppDllUid() const
	{
	return KUidCamera;
	}

/**
 Called by the UI framework at application start-up to
 create an instance of the document class.
 */
CApaDocument* CCameraApplication::CreateDocumentL()
	{
	return new (ELeave) CCameraDocument(*this);
	}
